package com.euler.yb.android.charts.charts;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import com.euler.yb.android.charts.Utils;
import com.euler.yb.android.charts.data.KlineData;
import com.github.mikephil.charting.animation.ChartAnimator;
import com.github.mikephil.charting.charts.CombinedChart;
import com.github.mikephil.charting.data.CandleEntry;
import com.github.mikephil.charting.data.Entry;
import com.github.mikephil.charting.formatter.IValueFormatter;
import com.github.mikephil.charting.highlight.Highlight;
import com.github.mikephil.charting.interfaces.dataprovider.CandleDataProvider;
import com.github.mikephil.charting.interfaces.datasets.ILineScatterCandleRadarDataSet;
import com.github.mikephil.charting.renderer.CandleStickChartRenderer;
import com.github.mikephil.charting.utils.ViewPortHandler;
import com.github.wuxudong.rncharts.R;

import java.util.Map;

/**
 * Created by Bo.Yang on 2018/4/8.
 */

public class EulerCandleStickChartRenderer  extends CandleStickChartRenderer {

    private String TAG = "EulerCandleStickChartRenderer";
    private Context mContext;
    private Path mHighlightLinePath = new Path();
    private CandleEntry candleEntry;//当前数据体
    private int index;//当前选中点序号
    private Paint paint=new Paint();
    public EulerCandleStickChartRenderer(CandleDataProvider chart, ChartAnimator animator, ViewPortHandler viewPortHandler) {
        super(chart, animator, viewPortHandler);
        //获取到上下文
        mContext=((CombinedChart)chart).getContext();
        paint.setColor(Color.WHITE);
    }
    @Override
    public void drawValue(Canvas c, IValueFormatter formatter, float value, Entry entry, int dataSetIndex, float x, float y, int color) {
        Map<String,Object> map= (Map<String, Object>) entry.getData();
        KlineData klineData= Utils.getKDataByMap(map);
        Bitmap bitmap=null;
        if(klineData.getAction()==1){
            mValuePaint.setColor(Color.RED);
            bitmap= BitmapFactory.decodeResource(mContext.getResources(), R.drawable.buy);
        }else if(klineData.getAction()==2){
            mValuePaint.setColor(Color.BLUE);
            bitmap= BitmapFactory.decodeResource(mContext.getResources(), R.drawable.sell);
        }
        if(bitmap!=null){
            c.drawBitmap(bitmap,x-12,y-35,null);
        }
    }
//    @Override
//    public void drawHighlighted(Canvas c, Highlight[] indices) {
//        if(indices.length>0){
//            index=(int)indices[0].getX();
//            candleEntry=mChart.getCandleData().getDataSetByIndex(0).getEntryForIndex(index);
//        }
//        super.drawHighlighted(c, indices);
//    }
//    /**
//     * 十字线的绘制方法
//     * @param c
//     * @param x
//     * @param y
//     * @param set
//     */
//    @Override
//    protected void drawHighlightLines(Canvas c, float x, float y, ILineScatterCandleRadarDataSet set) {
//        super.drawHighlightLines(c, x, y, set);
//        //取到数据，绘制十字线下面的日期和左边的值
////        Map<String,Object> map= (Map<String, Object>) candleEntry.getData();
////
////        String dateValue=map.get("reportdate").toString();
////        String yValue=map.get("close").toString();
////        //矩形画笔
////        Paint rectPaint=new Paint();
////        rectPaint.setColor(Color.BLACK);
////        rectPaint.setStyle(Paint.Style.STROKE);//空心
////        rectPaint.setStrokeWidth(1);//空心边框
////
////        //x轴显示文字画笔,文字宽度和高度
////        Paint xTextPaint=new Paint();
////        xTextPaint.setColor(Color.rgb(28,134,238));
////        xTextPaint.setTextSize(15);
////        xTextPaint.setAntiAlias(false);
////        Rect xrect=new Rect();
////        xTextPaint.getTextBounds(dateValue,0,dateValue.length(),xrect);
////        int xWidth=xrect.width();
////        int xHeight=xrect.height();
////
////        //y轴显示文字画笔，文字宽度和高度
////        Paint yTextPaint=new Paint();
////        yTextPaint.setColor(Color.rgb(28,134,238));
////        yTextPaint.setTextSize(15);
////        Rect yrect=new Rect();
////        yTextPaint.getTextBounds(yValue,0,yValue.length(),yrect);
////        int yWidth=yrect.width();
////        int yHeight=yrect.height();
////
////
////        //计算绘制矩形
////        float xleftTopx=x-(xWidth/2)-4;
////        float xleftTopy=mViewPortHandler.contentBottom()-(xHeight+4);
////        float xrightButtomx=x+(xWidth/2)+4;
////        float xrightButtomy=mViewPortHandler.contentBottom();
////        c.drawRect(xleftTopx,xleftTopy,xrightButtomx,xrightButtomy,rectPaint);
////        c.drawText(dateValue,xleftTopx+2,mViewPortHandler.contentBottom()-2,xTextPaint);
////
////
////
////        float yleftTopx=mViewPortHandler.contentRight()-yWidth-8;
////        float yleftTopy=y-(yHeight/2)-4;
////        float yrightButtomx=mViewPortHandler.contentRight();
////        float yrightButtony=y+(yHeight/2)+4;
////        c.drawRect(yleftTopx,yleftTopy,yrightButtomx,yrightButtony,rectPaint);
////        c.drawText(yValue,yleftTopx,yleftTopy+yHeight+4,yTextPaint);
//
////         copy源码写法绘制了十字线，稍微修改下长度，用于显示文字
//        // set color and stroke-width
//    }
}
