package com.euler.yb.android.charts.charts;

import android.content.Context;
import android.graphics.Canvas;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;

import com.github.mikephil.charting.charts.CombinedChart;
import com.github.mikephil.charting.data.CandleData;
import com.github.mikephil.charting.data.CombinedData;
import com.github.mikephil.charting.data.LineData;
import com.github.mikephil.charting.highlight.CombinedHighlighter;
import com.github.mikephil.charting.interfaces.dataprovider.CombinedDataProvider;

/**
 * Created by Bo.Yang on 2018/4/8.
 */

public class EulerCombinedChart  extends CombinedChart implements CombinedDataProvider{


    public EulerCombinedChart(Context context) {
        super(context);
    }

    public EulerCombinedChart(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public EulerCombinedChart(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
    }


    /**
     * 重写init方法，主要是为了使用自定义数据绘制渲染器
     */
    @Override
    protected void init() {
        super.init();
        // Default values are not ready here yet
        mDrawOrder = new DrawOrder[]{
                DrawOrder.BAR, DrawOrder.BUBBLE, DrawOrder.LINE, DrawOrder.CANDLE, DrawOrder.SCATTER
        };
        setHighlighter(new CombinedHighlighter(this, this));
        setHighlightFullBarEnabled(true);
        //使用自定义渲染器
        mRenderer=new EulerCombinedChartRenderer(this, mAnimator, mViewPortHandler);

    }




}
