package com.euler.yb.android.charts.markers;

import android.content.Context;
import android.graphics.Color;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.github.mikephil.charting.components.MarkerView;
import com.github.mikephil.charting.data.Entry;
import com.github.mikephil.charting.highlight.Highlight;
import com.github.wuxudong.rncharts.R;

import java.text.DecimalFormat;
import java.util.Map;
public class EulerKLineMarker extends MarkerView {


    private LinearLayout marker_back,marker,topLayout,buttomLayout;

    private TextView sname,syield,time,price,pl;//策略名称，收益率，成交时间，成交交个，盈亏(只有卖出有)

    private String TAG ="EulerKLineMarker";

    /**
     * Constructor. Sets up the MarkerView with a custom layout resource.
     *
     * @param context
     * @param layoutResource the layout resource to use for the MarkerView
     */
    public EulerKLineMarker(Context context, int layoutResource) {
        super(context,layoutResource);
         sname=(TextView)findViewById(R.id.text_sname);
         syield=(TextView)findViewById(R.id.text_syield);
         time=(TextView)findViewById(R.id.text_time);
         price=(TextView)findViewById(R.id.text_price);
         pl=(TextView)findViewById(R.id.text_pl);
         marker_back= (LinearLayout) findViewById(R.id.marker_back);
         marker=(LinearLayout) findViewById(R.id.marker);
         topLayout= (LinearLayout) findViewById(R.id.topLayout);
         buttomLayout=(LinearLayout) findViewById(R.id.buttomLayout);
    }




    @Override
    public void refreshContent(Entry e, Highlight highlight) {
        Map<String,Object> map= (Map<String, Object>) e.getData();
        int action= (int) map.get("action");
        String strategyName=null,strategyY=null,floatWinDate=null,tradePrice=null,profitLoss=null;

        if(action!=0){
            if(map.get("strategyName")!=null){
                strategyName=map.get("strategyName").toString();
            }
            if(map.get("strategyY")!=null){
                try {
                    double s= (double) map.get("strategyY")*100;
                    strategyY= new DecimalFormat("0.00").format(s);
                }catch (Exception s){
                    strategyY="0";
                }
            }
            if(map.get("floatWinDate")!=null){
                floatWinDate=map.get("floatWinDate").toString();
            }
            if(map.get("tradePrice")!=null){
                try {
                    double s= (double) map.get("tradePrice");
                    tradePrice= new DecimalFormat("0.00").format(s);
                }catch (Exception s){
                    tradePrice="0";
                }
            }
            if(map.get("profitLoss")!=null){
          try {
              double s= (double) map.get("profitLoss")*100;
              profitLoss= new DecimalFormat("0.00").format(s);
              }catch (Exception e1){
              profitLoss="0";
              }
            }
            marker_back.setVisibility(View.VISIBLE);
            switch (action){
                case 1://买入，不显示盈亏
                    marker.setBackgroundResource(R.drawable.shape_corner_buy);
                    topLayout.setBackgroundResource(R.drawable.shape_corner_buy_top);
                    pl.setVisibility(View.GONE);
                    sname.setText("  "+strategyName);
                    syield.setText("  策略总收益 "+strategyY+"%");
                    time.setText("  "+floatWinDate);
                    price.setText("  成交价 "+tradePrice);
                    break;
                case 2://卖出,显示盈亏
                    marker.setBackgroundResource(R.drawable.shape_corner_sell);
                    topLayout.setBackgroundResource(R.drawable.shape_corner_sell_top);
                    pl.setVisibility(View.VISIBLE);
                    pl.setBackgroundResource(R.drawable.shape_corner_pl);
                    sname.setText("  "+strategyName);
                    syield.setText("  策略总收益 "+strategyY+"%");
                    time.setText("  "+floatWinDate);
                    price.setText("  成交价 "+tradePrice);
                    pl.setText("  平仓盈亏 "+profitLoss+"%");
                    break;
                case 3://先卖出，再买入
                    marker.setBackgroundResource(R.drawable.shape_corner_sell);
                    topLayout.setBackgroundResource(R.drawable.shape_corner_sell_top);
                    pl.setVisibility(View.VISIBLE);
                    pl.setBackgroundResource(R.drawable.shape_corner_pl);
                    sname.setText("  "+strategyName);
                    syield.setText("  策略总收益 "+strategyY+"%");
                    time.setText("  "+floatWinDate);
                    price.setText("  成交价 "+tradePrice);
                    pl.setText("  平仓盈亏 "+profitLoss+"%");
                    break;
            }
        }else {
            marker_back.setVisibility(View.GONE);
        }
    }

}
