//
//  EulerCandleExtract.swift
//  euler_app_v1
//
//  Created by 小生不才 on 2018/4/25.
//  Copyright © 2018年 Facebook. All rights reserved.
//

import Foundation
import SwiftyJSON
import Charts

class RNEulerCandleDataExtract: CandleDataExtract {
  override func dataSetConfig(_ dataSet: IChartDataSet, config: JSON) {
    super.dataSetConfig(dataSet, config: config)
    let candleDataSet = dataSet as! CandleChartDataSet
    candleDataSet.drawValuesEnabled = false
    if config["drawValues"].bool != nil{
      candleDataSet.drawIconsEnabled = config["drawValues"].boolValue
    }
  }
  
  override func createEntry(_ values: [JSON], index: Int) -> CandleChartDataEntry {
    var entry: CandleChartDataEntry;
    
    var x = Double(index);
    let value = values[index];
    
    if value["x"].double != nil {
      x = Double(value["x"].doubleValue);
    }
    if value["shadowH"].double == nil || value["shadowL"].double == nil || value["open"].number == nil || value["close"].number == nil  {
      fatalError("invalid data " + values.description);
    }
    if value["action"].number != nil {
      switch(value["action"].number!.intValue){
      case 1:
        entry = CandleChartDataEntry(x: x,
                                     shadowH: value["shadowH"].doubleValue,
                                     shadowL: value["shadowL"].doubleValue,
                                     open: value["open"].doubleValue,
                                     close: value["close"].doubleValue,
                                     icon: NSUIImage(named: "buy"),
                                     data: value as AnyObject?)
      case 2:
        entry = CandleChartDataEntry(x: x,
                                     shadowH: value["shadowH"].doubleValue,
                                     shadowL: value["shadowL"].doubleValue,
                                     open: value["open"].doubleValue,
                                     close: value["close"].doubleValue,
                                     icon: NSUIImage(named: "sell"),
                                     data: value as AnyObject?)
      case 3:
        entry = CandleChartDataEntry(x: x,
                                     shadowH: value["shadowH"].doubleValue,
                                     shadowL: value["shadowL"].doubleValue,
                                     open: value["open"].doubleValue,
                                     close: value["close"].doubleValue,
                                     data: value as AnyObject?)
      default:
        entry = CandleChartDataEntry(x: x,
                                     shadowH: value["shadowH"].doubleValue,
                                     shadowL: value["shadowL"].doubleValue,
                                     open: value["open"].doubleValue,
                                     close: value["close"].doubleValue,
                                     data: value as AnyObject?)
      }
    } else {
      entry = CandleChartDataEntry(x: x,
                                   shadowH: value["shadowH"].doubleValue,
                                   shadowL: value["shadowL"].doubleValue,
                                   open: value["open"].doubleValue,
                                   close: value["close"].doubleValue,
                                   data: value as AnyObject?)
    }
    return entry
  }
}
