//
//  EulerCombinedChart.swift
//  euler_app_v1
//
//  Created by 小生不才 on 2018/4/16.
//  Copyright © 2018年 Facebook. All rights reserved.
//
import Charts
import SwiftyJSON


class RNEulerCombinedChartView: RNBarLineChartViewBase {
  let _chart: EulerCombinedChartView
  let _dataExtract: RNEulerCombinedDataExtract
  
  override var chart: EulerCombinedChartView {
    return _chart
  }
  
  override var dataExtract: DataExtract {
    return _dataExtract
  }
  
  override init(frame: CoreGraphics.CGRect) {
    
    self._chart = EulerCombinedChartView(frame: frame)
    self._dataExtract = RNEulerCombinedDataExtract()
    super.init(frame: frame)
    self._chart.delegate = self
    
    let candleMarker = ERCandleMarker(
      font: UIFont.systemFont(ofSize: 12.0),
      color: #colorLiteral(red: 1, green: 1, blue: 1, alpha: 1)
    )
    self._chart.marker = candleMarker
    self.addSubview(_chart)
  }
  
  required init?(coder aDecoder: NSCoder) {
    fatalError("init(coder:) has not been implemented")
  }
  
  /*
  override func setMarker(_ config: NSDictionary) {
    
    let json = BridgeUtils.toJson(config)
    
    if json["enabled"].exists() && !json["enabled"].boolValue {
      chart.marker = nil
      return
    }
    
    var markerFont = UIFont.systemFont(ofSize: 12.0)
    
    if json["textSize"].float != nil {
      markerFont = markerFont.withSize(CGFloat(json["textSize"].floatValue))
    }
    
    
    // TODO fontFamily, fontStyle
    let candleMarker = ERCandleMarker(
      font: markerFont,
      textColor: RCTConvert.uiColor(json["textColor"].intValue),
      titleColor: UIColor(red: 78/255.0, green:127/255.0, blue:211/255.0, alpha:0.8/1.0),
      contentColor: UIColor(red: 96/255.0, green:144/255.0, blue:226/255.0, alpha:0.8/1.0)
    )
    chart.marker = candleMarker
    
  }
 */
  
  
  func setDrawValueAboveBar(_ enabled: Bool) {
    _chart.drawValueAboveBarEnabled = enabled
  }
  
  func setDrawBarShadow(_ enabled: Bool) {
    _chart.drawBarShadowEnabled = enabled
  }
  
}
