//  Created by xudong wu on 23/02/2017.
//  Copyright wuxudong
//

import UIKit
import Charts

@objc(RNLineChartManager)
@objcMembers
open class RNLineChartManager: RCTViewManager, RNBarLineChartBaseManager {
  var _bridge: RCTBridge? {get{return self.bridge}}
  
  override open func view() -> UIView! {
    let ins = RNLineChartView()
    return ins;
  }

  override open static func requiresMainQueueSetup() -> Bool {
    return true;
  }
  
  @objc(receiveLineChartEntrys:type:args:)
  func receiveLineChartEntrys(reactTag:NSNumber,type:NSNumber,args: [String])  {
    DispatchQueue.main.async(execute: {
      let uiView = self.bridge.uiManager.view(forReactTag:reactTag)
      let lineChartView = (uiView is RNLineChartView) ? uiView as? RNLineChartView : nil
      if(lineChartView != nil){
        let lineChartData = lineChartView!.chart.lineData!
        for i in 0..<args.count{
          let lineChartEntry: ChartDataEntry
          if(type==0){
            lineChartEntry = ChartDataEntry(x: Double(lineChartData.getDataSetByIndex(i).entryCount + 121), y: Double(args[i])!)
          }else{
            lineChartEntry = ChartDataEntry(x: Double(lineChartData.getDataSetByIndex(i).entryCount + 1), y: Double(args[i])!)
          }
          lineChartData.addEntry(lineChartEntry, dataSetIndex: i)
        }
        lineChartView?.chart.notifyDataSetChanged()
        lineChartView?.chart.invalidateIntrinsicContentSize()
      }
    })
  }
  
  func moveViewToX(_ reactTag: NSNumber, xValue: NSNumber) {
    (self as RNBarLineChartBaseManager)._moveViewToX(reactTag, xValue: xValue)
  }
  
  func moveViewTo(_ reactTag: NSNumber, xValue: NSNumber, yValue: NSNumber, axisDependency: NSString) {
    (self as RNBarLineChartBaseManager)._moveViewTo(reactTag, xValue: xValue, yValue: yValue, axisDependency: axisDependency)
  }
  
  func moveViewToAnimated(_ reactTag: NSNumber, xValue: NSNumber, yValue: NSNumber, axisDependency: NSString, duration: NSNumber) {
    (self as RNBarLineChartBaseManager)._moveViewToAnimated(reactTag, xValue: xValue, yValue: yValue, axisDependency: axisDependency, duration: duration)
  }
  
  func centerViewTo(_ reactTag: NSNumber, xValue: NSNumber, yValue: NSNumber, axisDependency: NSString) {
    (self as RNBarLineChartBaseManager)._centerViewTo(reactTag, xValue: xValue, yValue: yValue, axisDependency: axisDependency)
  }
  
  func centerViewToAnimated(_ reactTag: NSNumber, xValue: NSNumber, yValue: NSNumber, axisDependency: NSString, duration: NSNumber) {
    (self as RNBarLineChartBaseManager)._centerViewToAnimated(reactTag, xValue: xValue, yValue: yValue, axisDependency: axisDependency, duration: duration)
  }
  
  func fitScreen(_ reactTag: NSNumber) {
    (self as RNBarLineChartBaseManager)._fitScreen(reactTag)
  }

}
