import PropTypes from 'prop-types';
import React, {Component} from 'react';
import {
  requireNativeComponent,
  View
} from 'react-native';

import BarLineChartBase from './BarLineChartBase';
import {combinedData} from './ChartDataConfig';
import MoveEnhancer from './MoveEnhancer'
import ScaleEnhancer from "./ScaleEnhancer";

class EulerCombinedChart extends React.Component {
  getNativeComponentName() {
    return 'RNEulerCombinedChart'
  }

  getNativeComponentRef() {
    return this.nativeComponentRef
  }

  render() {
    return <RNEulerCombinedChart {...this.props} ref={ref => this.nativeComponentRef = ref} />;
  }
}

EulerCombinedChart.propTypes = {
  ...BarLineChartBase.propTypes,
  data: combinedData
};

var RNEulerCombinedChart = requireNativeComponent('RNEulerCombinedChart', EulerCombinedChart, {
  nativeOnly: {onSelect: true, onChange: true}
});

export default ScaleEnhancer(MoveEnhancer(EulerCombinedChart))
